function imsim(testim)

%convert query image to double
queryim=testim;
queryim=queryim(:);

%read images
moon1=imread('moon1.jpg');
moon2=imread('moon2.jpg');
moon4=imread('moon4.jpg');    
blood1=imread('blood1.jpg');    
face1=imread('face1.jpg');    
face2=imread('face2.jpg');   

%read images
picdata=[moon1(:), moon2(:), moon4(:), blood1(:), face1(:), face2(:)];
names=[{'moon1'};{'moon2'};{'moon4'};{'blood1'};{'face1'};{'face2'}];
y=ones(6,4);

%HISTOGRAM BASED METHODS
    for picno=1:6
        %histogram based similarity
        histdist = norm(imhist(picdata(:,picno))-imhist(queryim));
        y(picno,1)=y(picno,1)*histdist;
        
        %histogram similarity using absolute val
        histab = sum(abs(imhist(picdata(:,picno))-imhist(queryim)));
        y(picno,2)=y(picno,2)*histab;
        
        %histogram similarity using squared val
        histsq = sum((imhist(picdata(:,picno))-imhist(queryim)).^2);
        y(picno,3)=y(picno,3)*histsq;
        
        %histogram similarity using statistical val
        m(:,1)=max(imhist(picdata(:,picno)),imhist(queryim));
        for t=1:size(m,1)
            if m(t,1)==0
                m(t,1)=1 ;
            else
                m(t,1)=m(t,1);
            end
        end
        histstat = sum(((imhist(picdata(:,picno))-imhist(queryim)).^2)./m);
        y(picno,4)=y(picno,4)*histstat;
    end
    
    
    %displaying result in order
    
    disp('   RESULTS BASED ON HISTOGRAM BASED IMAGE SIMILARITY    ');
       
    disp('    HISTDIST    HISTAB       HISTSQ      HISTSTAT');
    for j=1:4
        for i=1:6
            [value,index]=min(y(:,j));
            mostsim1(i,j)=names(index,1);
            y(index,j)=5000000000;
        end
    end
    disp(mostsim1);
        
        
    
    
    
   