function imsim(testim)

%convert query image to double
queryim=double(testim);
queryim=queryim(:);

%read images
moon1=double(imread('moon1.jpg'));
moon2=double(imread('moon2.jpg'));
moon4=double(imread('moon4.jpg'));    
blood1=double(imread('blood1.jpg'));    
face1=double(imread('face1.jpg'));    
face2=double(imread('face2.jpg'));   

%read images
picdata=[moon1(:), moon2(:), moon4(:), blood1(:), face1(:), face2(:)];
names=[{'moon1'};{'moon2'};{'moon4'};{'blood1'};{'face1'};{'face2'}];
x=ones(6,5);
  
%PIXEL BASED METHODS
    for picno=1:6   
        %pixel based similarity
        pixdist = norm(picdata(:,picno)-queryim);
        x(picno,1)=x(picno,1)*pixdist;   
        
        %pixel to pixel using absolute val
        pixab=sum(abs(picdata(:,picno)-queryim));
        x(picno,2)=x(picno,2)*pixab;
        
        %pixel to pixel using squared val
        pixsq=sum((picdata(:,picno)-queryim).^2);
        x(picno,3)=x(picno,3)*pixsq;
        
        %pixel to pixel using mean and variance
        wh=size(queryim,1)*size(queryim,2);
        %mean
        pixmean=(sum(picdata(:,picno)-queryim))/wh;
        %variance
        varsq=(sum(((picdata(:,picno)-queryim)-pixmean).^2))/(wh-1);
        var=sqrt(varsq);
        
        if var==0 
            pixvar=0;
        else
            pixvar=sqrt(wh)*(pixmean/var);
        end
        
        x(picno,4)=x(picno,4)*pixvar;
        
        %pixel to pixel using normalised products
        pixnorm=1-(dot(picdata(:,picno),queryim))/(norm(picdata(:,picno))*norm(queryim));
        x(picno,5)=x(picno,5)*pixnorm;
    end
    
    disp('   RESULTS BASED ON PIXEL BASED IMAGE SIMILARITY    ');
       
    disp('    PIXDIST      PIXAB       PIXSQ      PIXVAR      PIXNORM');
    for j=1:5
        for i=1:6
            [value,index]=min(x(:,j));
            mostsim(i,j)=names(index,1);
            x(index,j)=5000000000;
        end
    end
    disp(mostsim);
    

    
    
        
   
      
    
      
        
    
   